<template>
    <div class="subscribes__table">
        <b-form-input
            v-model="searchQuery"
            class="my-input"
            type="text"
            name="search"
            placeholder="Search"
            @keyup="search(1)"
        />
        <div v-if="smsSubscribers.subscribers[0]">
            <div class="table-responsive">
                <table class="table-hover">
                    <thead class="table-header">
                        <tr>
                            <th class="table-first-cell">
                                SMS
                            </th>
                            <th>Status</th>
                            <th>Subscribed</th>
                            <th>Last Active</th>
                            <th>Message history</th>
                            <th />
                        </tr>
                    </thead>
                    <tbody class="table-body">
                        <tr
                            v-for="(subscriber, index) in smsSubscribers.subscribers"
                            :key="index"
                            class="open-modal-tr"
                        >
                            <th
                                class="table-first-cell"
                                @click="$bvModal.show('bv-modal-subscriber'+ subscriber.id)"
                            >
                                {{ subscriber.phone }}
                            </th>
                            <th @click="$bvModal.show('bv-modal-subscriber'+ subscriber.id)">
                                <span
                                    v-if="subscriber.sms_subscribed || subscriber.subscribed"
                                    class="subscribed-title"
                                >Subscriber</span>
                                <span
                                    v-else
                                    class="unsubscribed-title"
                                >Unsubscribed</span>
                            </th>
                            <th @click="$bvModal.show('bv-modal-subscriber'+ subscriber.id)">
                                <span v-if="isSame(subscriber.created_at)">
                                    Today
                                </span>
                                {{ subscriber.created_at | moment('from') }}
                            </th>
                            <th @click="$bvModal.show('bv-modal-subscriber'+ subscriber.id)">
                                <span v-if="isSame(subscriber.updated_at)">
                                    Today
                                </span>
                                {{ subscriber.updated_at | moment('from') }}
                            </th>
                            <th @click="[$bvModal.show('bv-modal-subscriber-sent'+ subscriber.id), showHistory(subscriber.id)]">
                                <a
                                    class="show-history"
                                    href="#"
                                >Show History</a>
                            </th>
                            <th>
                                <b-btn
                                    class="btn red-button"
                                    @click="[deleteModal = true, subscriberId = subscriber.id]"
                                >
                                    Delete
                                </b-btn>
                            </th>
                            <b-modal
                                :id="'bv-modal-subscriber'+ subscriber.id"
                                size="md"
                                hide-backdrop
                                content-class="shadow"
                                hide-footer
                            >
                                <template
                                    #default="{ hide }"
                                    class="subscribers-container"
                                >
                                    <div class="row">
                                        <div class="col-sm-6">
                                            <div class="modal-avatar">
                                                <img src="/images/no-avatar.png">
                                            </div>
                                            <ul>
                                                <li>
                                                    <p
                                                        v-if="subscriber.sms_subscribed || subscriber.subscribed"
                                                        class="text-success"
                                                    >
                                                        Subscriber (<a
                                                            href="#"
                                                            @click.prevent="[changeStatus(subscriber.id, false), hide()]"
                                                        >Unsubscribe</a>)
                                                    </p>
                                                    <p
                                                        v-else
                                                        class="text-muted"
                                                    >
                                                        Unsubscribed (<a
                                                            href="#"
                                                            @click.prevent="[changeStatus(subscriber.id, true), hide()]"
                                                        >Subscribe</a>)
                                                    </p>
                                                </li>
                                                <li>
                                                    Country:
                                                    {{ subscriber.country || 'unknown' }}
                                                </li>
                                            </ul>
                                        </div>
                                        <div class="col-sm-6">
                                            <div class="subscriber-email">
                                                {{ subscriber.phone }}
                                            </div>
                                            <!--                                            <div class="tags-container">-->
                                            <!--                                                <div>User Tags</div>-->
                                            <!--                                                <b-form-input class="form-control tag-input"-->
                                            <!--                                                              placeholder="Add Tags"></b-form-input>-->
                                            <!--                                            </div>-->
                                            <div class="checkout-modal-container">
                                                <p>Opted In through</p>
                                                <p class="bg-primary">
                                                    <span v-if="subscriber.growth_hash">Growth tools</span>
                                                    <span v-else>Checkout</span>
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                </template>
                            </b-modal>
                            <b-modal
                                :id="'bv-modal-subscriber-sent' + subscriber.id"
                                size="md"
                                hide-backdrop
                                content-class="shadow"
                                hide-footer
                            >
                                <div
                                    v-if="subscribersSent"
                                    class="modal-table-container"
                                >
                                    <table
                                        v-if="subscribersSent[0]"
                                        class="table table-bordered table-sent"
                                    >
                                        <thead>
                                            <tr />
                                            <tr>
                                                <th>SMS Status</th>
                                                <th>SMS Price</th>
                                                <th>Date</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr
                                                v-for="(sent, index) in subscribersSent"
                                                :key="index"
                                            >
                                                <td>{{ sent.status }}</td>
                                                <td>${{ sent.price }}</td>
                                                <td>
                                                    {{
                                                        getDate(sent)
                                                    }}
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div
                                        v-else
                                        class="no-data-text"
                                    >
                                        No data
                                    </div>
                                </div>
                            </b-modal>
                        </tr>
                        <b-modal
                            v-model="deleteModal"
                            size="md"
                            hide-backdrop
                            content-class="shadow"
                            title="Are you sure you want to delete this subscriber?"
                            hide-footer
                        >
                            <b-btn
                                type="button"
                                class="btn red-button"
                                @click="deleteSubscribersSms(subscriberId)"
                            >
                                Yes
                            </b-btn>
                            <b-btn
                                type="button"
                                class="btn light-blue-btn"
                                @click="deleteModal = false"
                            >
                                No
                            </b-btn>
                        </b-modal>
                    </tbody>
                </table>
            </div>
            <paginate
                v-model="pageNumber.number"
                :page-count="Math.ceil(smsSubscribers.total_subscribers / smsSubscribers.limit)"
                :click-handler="pageEmailHandler"
                :prev-text="'Previous'"
                :next-text="'Next'"
                :container-class="'pagination'"
            />
        </div>
        <div v-else>
            Not Found
        </div>
    </div>
    <!--            <div class="col-lg-3">-->
    <!--                <div class="filter-container">-->
    <!--                    <div class="filter-title">-->
    <!--                        <a href="#" class="active-all">All</a>-->
    <!--                    </div>-->
    <!--                    <div class="text-subscribers">-->
    <!--                        {{ smsSubscribers.total_subscribers }} Subscribers-->
    <!--                    </div>-->
    <!--                </div>-->
    <!--            </div>-->
</template>

<script>
import headers from '../../../helpers/authHeader';
import link from '../../../helpers/backLink';

export default {
    name: "SmsTable",
    mixins: [headers, link],
    props: ['smsSubscribers', 'pageNumber'],
    data() {
        return {
            searchQuery: '',
            subscribersSent: null,
            deleteModal: false,
            subscriberId: null,
        }
    },
    methods: {
        getDate(sent) {
            const value = sent.created_at ||  sent.updated_at
            return this.$formatter.dateFormat(value, 'YYYY-MM-DD hh:mm:ss')
        },
        pageEmailHandler(e) {
            return this.$emit('getSmsSubscribers', e)
        },
        showHistory(id) {
            axios.get(this.getSegment() + '/home/sms/subscribers/sent/' + id, this.getUserHeader()).then(response => this.subscribersSent = response.data)
        },
        search(pageNum = 1) {
            this.pageNumber.number = pageNum;
            axios.get(this.getSegment() + '/home/sms/subscribers/?search=' + this.searchQuery, this.getUserHeader()).then(response => {
                this.smsSubscribers.subscribers = response.data.subscribers;
            });
        },
        changeStatus(id, status) {
            axios.put(this.getSegment() + '/home/sms/subscribers/' + id + '/status/', {status}, this.getUserHeader()).then(response => {
                this.$emit('getSmsSubscribers')
            });
        },
        isSame(date) {
            return moment().isSame(date, 'day');
        },
        deleteSubscribersSms(id) {
            axios.delete(this.getSegment() + '/home/sms/subscribers/' + id, this.getUserHeader()).then(response => {
                this.$emit('getSmsSubscribers')
                this.deleteModal = false
                this.$notify({
                    type: 'success',
                    title: 'Deleted'
                });
            })
        }
    }
}
</script>

<style scoped lang="scss">

.pagination {
    padding: 0 !important;
}

.no-data-text {
    text-align: center;
    font-size: 20px;
    font-weight: 500;
}

.table-sent {
    text-align: center;
}

.table-hover {
    min-width: 600px;
}

.table-first-cell {
    text-align: left;
}

.subscribed-title {
    color: #2BB300;
}

.unsubscribed-title {
    color: #8492a6;
}

.checkout-modal-container {
    position: absolute;
    bottom: 0;
}

.active-all {
    font-weight: 600;
    color: #4786FF;
}

.text-subscribers {
    color: #8492a6;
}

.modal-avatar {
    margin-bottom: 15px;
}

.open-modal-tr {
    cursor: pointer;
}

ul {
    padding-inline-start: 20px;

    p {
        margin-bottom: 10px;
    }
}

.subscriber-email {
    margin-top: 15px;
    margin-bottom: 20px;
    padding-bottom: 20px;
    font-size: 16px;
    font-weight: 400;
    color: #4786FF;
    border-bottom: 1px solid #e0e6ed;
}

.bg-primary {
    display: table;
    margin-top: 15px;
    padding: 7px 15px;
    background: rgba(45, 119, 244, 0.07) !important;
    color: #4786FF;
}

.tags-container {
    margin-top: 10px;
    margin-bottom: 40px;
}

.tag-input {
    margin-top: 5px;
}

.filter-container {
    margin-top: 25px;
    min-width: 220px;
    display: flex;
    justify-content: space-between;
}

.table-header {
    padding: 10px;
}

.my-input {
    max-width: 280px;
    position: absolute;
    top: -70px;
}

.table-body {
    background: white;
    border-radius: 5px;

    &:hover {
        background: #fbfcfd;
    }
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}


</style>
